import java.awt.*;
import java.awt.event.*;

public class AppBar extends Panel implements ActionListener, ItemListener
{
	private Color moduleBtnColor    = new Color(255, 255, 68);
	private Color moduleFocusColor  = new Color(228, 228, 228);
	private Color moduleLoadedColor = Color.red;

	private Choice ISPList;
	private int curISPIndex=0;

	public AppBar()
	{
		this.setLayout(null);
		this.setBounds(0, 0, AppConfig.AppBarWidth, AppConfig.TotalHeight);
		this.setBackground(AppConfig.Color_AppBar);

		ISPList = new Choice();
		ISPList.setFont(new Font("SansSerif", Font.BOLD, 11));
		ISPList.setBounds(12, 27, AppConfig.AppBarWidth-24, 23);
		ISPList.addItemListener(this);
		this.add(ISPList);

		for(int i=0; i < 5; i++)
		{
			XButton	btn = new XButton(AppModule.moduleName[i]);
			btn.setBounds(14, 85+(30*i),  AppConfig.AppBarWidth-28, 25);
			btn.setColor(moduleBtnColor);
			btn.setFocusColor(moduleFocusColor);
			btn.addActionListener(this);
			btn.setActionCommand(AppModule.moduleName[i]);
			this.add(btn);
		}

	}

	public void refreshISPList()
	{
		String[] ispList = AppConfig.ispvnNameList;
		for(int i=0; i < ispList.length; i++) ISPList.add(ispList[i]);
	}

	public void paint(Graphics g)
	{
		//Draw Box for IspList
		XToolkit.setColorScheme(XToolkit.COLORSCHEME_SHARP3D);
		XToolkit.draw3DBox(g, 10, 25, AppConfig.AppBarWidth-20, 25, false);

		//Draw Box for Modules Menu
		XToolkit.draw3DBox(g, 10, 75, AppConfig.AppBarWidth-20, 165, false);
	}

	//Event Handler for All Actions
	public void actionPerformed(ActionEvent e)
	{
		AppConfig.getBillingApplet().setModule(e.getActionCommand());
		//try {
		//appContext.showDocument(new URL(getDocumentBase(),"event.html"), "Footer");
		//} catch (Exception ex) { System.out.println("URL Error: "+ex.toString()); }
	}

	public void itemStateChanged(ItemEvent e)
	{
		int newIndex = ISPList.getSelectedIndex();
		if(newIndex != curISPIndex)
		{	curISPIndex = newIndex;
			AppConfig.getBillingApplet().setIspvn(newIndex);
		}
	}

}
