import java.awt.*;
import java.net.URL;
import java.util.Calendar;
import java.text.SimpleDateFormat;

public class AppConfig
{
	//Color Definitions
	static final Color Color_Browser = Color.gray;
	static final Color Color_AppBar  = new Color(224, 198, 0);
	static final Color Color_Client  = Color.lightGray;
	static final Color Color_ModuleTitleBar = new Color(168, 168, 168);

	//Predefined fonts
	static final Font Font_11 = new Font("SansSerif", Font.PLAIN, 11);
	static final Font Font_12 = new Font("SansSerif", Font.PLAIN, 12);
	static final Font Font_13 = new Font("SansSerif", Font.PLAIN, 13);
	static final Font Font_14 = new Font("SansSerif", Font.PLAIN, 14);
	static final Font Font_B11 = new Font("SansSerif", Font.BOLD, 11);
	static final Font Font_B12 = new Font("SansSerif", Font.BOLD, 12);
	static final Font Font_B13 = new Font("SansSerif", Font.BOLD, 13);
	static final Font Font_B14 = new Font("SansSerif", Font.BOLD, 14);
	static final Font Font_ModuleTitle = new Font("SansSerif", Font.BOLD, 16);

	//Cursors
	static final Cursor Cursor_HAND    = Cursor.getPredefinedCursor(Cursor.HAND_CURSOR);
	static final Cursor Cursor_DEFAULT = Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR);

	//Layout Definitions
	static final int TotalWidth   = 1280;
	static final int TotalHeight  = 780;
	static final int ClientWidth  = 1130;
	static final int ClientIndent = 150;
	static final int AppBarWidth  = 140;
	static final int SepBarWidth  = 10;
	static final int ModuleTop    = 55;
	static final int DividerTop   = 60;
	static final int CustPanelTop    = 0;
	static final int CustPanelIndent = 150;
	static final int CustPanelHeight = 50;

	static String portalURL=null;
	static String operatorID="0";

	static BillingApplet billingApplet=null;
	static AppBar billingAppBar=null;
	static AppModule billingModule=null;
	static CustomerPanel customerPanel=null;

	static String[] ispvnNameList = new String[0];
	static String[] ispvnIDList = new String[0];
	static int curIspvnIndex = 0;

	//HttpCommunicator
	static HttpCommunicator httpCommunicator = new HttpCommunicator();

	//XMLParser
	static XMLParser xmlParser = new XMLParser();

	//Cached XML Documents
	static Document[] DocumentCache = new Document[16];
	static long[] DocumentFetchTime = new long[16];
	static final long   CacheTimeout = 300000;

	//Cached Documents ID
	static final int DOC_ACCOUNT_ID    = 0;
	static final int DOC_ACCOUNT_FNAME = 1;
	static final int DOC_ACCOUNT_LNAME = 2;

	static final int SHOW_HTML   = 101;
	static final int CLOSE_HTML  = 102;
	static final int EXPORT_DATA = 103;
	static int htmlMessage=SHOW_HTML;
	static final String htmlHeader = "<html><head><title>Billing Portal Html Viewer</title></head><body bgcolor=white>";
	static String htmlData = "";

	static Calendar dCalendar = Calendar.getInstance();
	static SimpleDateFormat dFormat = new SimpleDateFormat ("MM/dd/yyyy");

	public static void reset()	//reinitializes all static varibles to cut memory effect
	{
		billingApplet=null;
		billingAppBar=null;
		billingModule=null;

		portalURL=null;
		ispvnNameList = new String[0];
		ispvnIDList   = new String[0];
		curIspvnIndex = 0;

		DocumentCache = new Document[16];
		DocumentFetchTime = new long[16];
	}

	public static void setBillingApplet(BillingApplet bApp) { billingApplet = bApp; }
	public static BillingApplet getBillingApplet() { return billingApplet; }

	public static void setAppBar(AppBar tbar) { billingAppBar = tbar; }
	public static AppBar getAppBar() { return billingAppBar; }

	public static void setActiveModule(AppModule tMod)	{ billingModule = tMod; }
	public static AppModule getActiveModule() { return billingModule; }

	public static void setCustomerPanel(CustomerPanel tp) { customerPanel = tp; }
	public static CustomerPanel getCustomerPanel() { return customerPanel; }

	public static HttpCommunicator getCommunicator() { return httpCommunicator; }

	public static XMLParser getParser() { return xmlParser; }

	public static void setHtmlData(String hData) { htmlData = hData; }
	public static String getHtmlData() { return htmlHeader+htmlData+"</body></html>"; }
	public static void sendHtmlMessage(int hMsg)
	{
		htmlMessage = hMsg;
		try {
		if(htmlMessage == SHOW_HTML)
			billingApplet.appContext.showDocument(new URL(billingApplet.getDocumentBase(),"AppMessage.html"), "tmpf0101xxyy0");
		else if(htmlMessage == EXPORT_DATA)
			billingApplet.appContext.showDocument(new URL(billingApplet.getDocumentBase(),htmlData), "tmpf0101xxyy0");
		} catch (Exception ex) { System.out.println("URL Error: "+ex.toString()); }
	}
	public static String getHtmlMessage()
	{
		if(htmlMessage == SHOW_HTML) return "SHOW_HTML";
		else if(htmlMessage == CLOSE_HTML) return "CLOSE_HTML";
		return "NONE";
	}

	//Date Utils
	public static String getDate(boolean reset)
	{
		if(reset) dCalendar = Calendar.getInstance();
		return dFormat.format(dCalendar.getTime());
	}

	public static void adjustDate(boolean reset, int dpart, int amt)
	{
		if(reset) dCalendar = Calendar.getInstance();
		dCalendar.add(dpart, amt);
	}
}
