import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.Vector;

public class CustomerPanel extends Panel implements ActionListener, KeyListener, HttpListener
{
	public static final int SELECTOPTION_SINGLE = 1;
	public static final int SELECTOPTION_MULTIPLE = 2;
	public static final int SELECTOPTION_RANGE = 3;

	private Color custBtnFocusColor = new Color(228, 228, 228);
	private static final int cIndent=20;
	private int pX=AppConfig.CustPanelIndent, pY=AppConfig.CustPanelTop, pW=510, pH=115;
	//private static final int cX=3, cY=18, cW=422, cH=70;
	private static final int cX=3, cY=0, cW=422, cH=88;

	private XButton btnS, btnSM, btnSR, btnOK;
	private Panel pSelection = new Panel();
	private Panel pSearch = new Panel();
	private TextField idTx, fnameTx, lnameTx;
	private Button btnFind, btnClear;

	private XGrid custList, custTable;
	private Label custTitle, cMsg;

	private int custDocType = AppConfig.DOC_ACCOUNT_ID;
	private int reqDocType  = AppConfig.DOC_ACCOUNT_ID;
	private boolean isSelecting=false;
	private int selectOption = SELECTOPTION_SINGLE;

	Vector selectedCustomers = new Vector();

	public CustomerPanel()
	{
		this.setLayout(null);
		this.setBounds(pX, pY, pW, pH);
		this.setBackground(AppConfig.Color_Client);

		//add selection panel
		this.add(pSelection);

		//custTitle = new Label("Customers");
		//custTitle.setFont(AppConfig.Font_B13);
		//custTitle.setBounds(0, 0, 70, 18);
		//pSelection.add(custTitle);

		custList = new XGrid("Customers");
		custList.setBounds(cX, cY, cW, cH);
		custList.setContentBackground(AppConfig.Color_ModuleTitleBar);
		custList.setContentForeground(custBtnFocusColor);
		custList.setDataFont(AppConfig.Font_12);
		//custList.setColumns(new int[]{35, 50, 40, 110, 55, 25, 55, 50});
		custList.setColumns(new int[]{100, 150, 60, 108});
		custList.setHeader(new String[]{ "Account No", "Name", "Prepaid", "Balance"});
		custList.displayPageTabs(true);
		custList.setPageSize(3);
		custList.setBorderV(0);
		custList.setRowHeight(17);
		custList.setColProperty(0, XGrid.PROP_TEXTCOLOR, Color.red);
		pSelection.add(custList);
		custList.doLayout();

		btnS = new XButton("Select");
		btnS.setBounds(cX, cY+cH+5, 120, 22);
		btnS.setColor(Color.lightGray);
		btnS.setFocusColor(custBtnFocusColor);
		btnS.addActionListener(this);
		btnS.setActionCommand("Select");
		pSelection.add(btnS);

		btnSM = new XButton("Select Multiple");
		btnSM.setBounds(cX+122, cY+cH+5, 120, 22);
		btnSM.setColor(Color.lightGray);
		btnSM.setFocusColor(custBtnFocusColor);
		btnSM.addActionListener(this);
		btnSM.setActionCommand("SelectMultiple");
		pSelection.add(btnSM);

		btnSR = new XButton("Select Range");
		btnSR.setBounds(cX+244, cY+cH+5, 120, 22);
		btnSR.setColor(Color.lightGray);
		btnSR.setFocusColor(custBtnFocusColor);
		btnSR.addActionListener(this);
		btnSR.setActionCommand("SelectRange");
		pSelection.add(btnSR);

		//add search panel
		pSearch.setBounds(cIndent, pY, 160, pH);
		pSearch.setVisible(false);
		this.add(pSearch);
		Label sL = new Label("Search");
		sL.setFont(AppConfig.Font_B13);
		sL.setBounds(0, 0, 70, 18);
		pSearch.add(sL);
		Label idL = new Label("Customer Code");
		idL.setBounds(0, 20, 80, 20);
		pSearch.add(idL);
		idTx = new TextField();
		idTx.setBounds(80, 20, 80, 21);
		idTx.addKeyListener(this);
		pSearch.add(idTx);
		Label fnL = new Label("First Name");
		fnL.setBounds(0, 44, 80, 20);
		pSearch.add(fnL);
		fnameTx = new TextField();
		fnameTx.setBounds(80, 44, 80, 21);
		fnameTx.addKeyListener(this);
		pSearch.add(fnameTx);
		Label lnL = new Label("Last Name");
		lnL.setBounds(0, 68, 80, 20);
		pSearch.add(lnL);
		lnameTx = new TextField();
		lnameTx.setBounds(80, 68, 80, 21);
		lnameTx.addKeyListener(this);
		pSearch.add(lnameTx);

		btnFind = new Button("Find Now");
		btnFind.setBounds(0, 93, 79, 22);
		btnFind.setBackground(AppConfig.Color_ModuleTitleBar);
		btnFind.addActionListener(this);
		btnFind.setActionCommand("FIND");
		pSearch.add(btnFind);

		btnClear = new Button("New Search");
		btnClear.setBounds(81, 93, 79, 22);
		btnClear.setBackground(AppConfig.Color_ModuleTitleBar);
		btnClear.addActionListener(this);
		btnClear.setActionCommand("CLEAR");
		pSearch.add(btnClear);

		btnOK = new XButton("Close");
		btnOK.setBounds(cX, cY+cH+5, 120, 22);
		btnOK.setColor(Color.lightGray);
		btnOK.setFocusColor(custBtnFocusColor);
		btnOK.addActionListener(this);
		btnOK.setActionCommand("CLOSE");
		btnOK.setVisible(false);
		pSelection.add(btnOK);

		cMsg = new Label();
		cMsg.setBounds(cIndent, AppConfig.DividerTop+20, 400, 18);
		cMsg.setForeground(Color.gray);
		cMsg.setFont(AppConfig.Font_B12);
		this.add(cMsg);

		custTable = new XGrid();
		custTable.setBounds(cIndent, AppConfig.DividerTop+40, 550, 240);
		custTable.setContentBackground(AppConfig.Color_ModuleTitleBar);
		custTable.setContentForeground(custBtnFocusColor);
		//custTable.setDataFont(AppConfig.Font_B12);
		custTable.setColumns(new int[]{65, 110, 110, 136, 45, 80, 0});
		custTable.setHeader(new String[]{ "Account No", "First Name", "Last Name", "Company", "Prepaid", "Balance", " " });
		custTable.displayPageTabs(true);
		custTable.setColProperty(0, XGrid.PROP_TEXTCOLOR, Color.red);
		custTable.setColProperty(0, XGrid.PROP_TEXTFONT, AppConfig.Font_B12);
		custTable.setColProperty(0, XGrid.PROP_DATALINK, "Y");
		custTable.setLinkListener(this, "LINK_SELECTED");
		custTable.setVisible(false);
		this.add(custTable);
	}

	public void reset()
	{
		//System.out.println("CustomerPanel reset: "+AppConfig.curIspvnIndex);
		selectedCustomers.removeAllElements();
		custList.reset();
		custTable.reset();
		setSelectionMode(false);
		//clear Caches
		AppConfig.DocumentCache[AppConfig.DOC_ACCOUNT_ID] = null;
		AppConfig.DocumentCache[AppConfig.DOC_ACCOUNT_FNAME] = null;
		AppConfig.DocumentCache[AppConfig.DOC_ACCOUNT_LNAME] = null;
	}

	public void setSelectionMode(boolean select)
	{
		if(select)
		{	if(isSelecting) return;	//nothing to do
			isSelecting = true;
			super.setBounds(0, 0, AppConfig.ClientWidth, AppConfig.TotalHeight);
			pSelection.setLocation(pX, pY);
			btnS.setVisible(false); btnSM.setVisible(false); btnSR.setVisible(false);
			pSearch.setVisible(true);
			btnOK.setVisible(true);
			custTable.setVisible(true);
			loadCustomerData("");	//fill custTable with data
		}
		else
		{	if(!isSelecting) return;	//nothing to do
			isSelecting = false;
			super.setBounds(pX, pY, pW, pH);
			pSelection.setLocation(0, 0);
			btnS.setVisible(true); btnSM.setVisible(true); btnSR.setVisible(true);
			pSearch.setVisible(false);
			btnOK.setVisible(false);
			custTable.setVisible(false);
		}
	}

	public void setBounds(int x, int y, int width, int height)
	{
		super.setBounds(x, y, width, height);
		pSelection.setBounds(0, 0, width, height);
		pX = x;  pY = y;  pW = width;  pH = height;
	}

	public void setBounds(Rectangle r)
	{
		this.setBounds(r.x, r.y, r.width, r.height);
	}

	public void paint(Graphics g)
	{
		if(isSelecting)
		{
		g.setColor(AppConfig.Color_ModuleTitleBar);
		g.fillRect(0, 0, AppConfig.ClientWidth, 20);
		XToolkit.setColorScheme(XToolkit.COLORSCHEME_SOFT3D);
		XToolkit.draw3DBox(g, 0, 0, AppConfig.ClientWidth+1, 21, true);
		g.setColor(Color.white);
		g.setFont(AppConfig.Font_ModuleTitle);
		g.drawString("Customer Selection", 5, 16);
		XToolkit.setColorScheme(XToolkit.COLORSCHEME_SHARP3D);
		XToolkit.draw3DLineH(g, 0, AppConfig.DividerTop, AppConfig.ClientWidth+1, 1, false);
		}
	}

	//Event Handler for All Actions
	public void actionPerformed(ActionEvent e)
	{
		Object eventObj = e.getSource();	//e.getActionCommand();

		//if one of the select buttons pressed
		if(eventObj == btnS)
		{	resetForSelection();
			selectOption = SELECTOPTION_SINGLE;
			cMsg.setText("Please select customer from the following list:");
			setSelectionMode(true);
			return;
		}
		if(eventObj == btnSM)
		{	resetForSelection();
			selectOption = SELECTOPTION_MULTIPLE;
			cMsg.setText("Please select one or more customers from the following list:");
			setSelectionMode(true);
			return;
		}
		if(eventObj == btnSR)
		{	resetForSelection();
			selectOption = SELECTOPTION_RANGE;
			cMsg.setText("Please select a range of customers from the following list:");
			setSelectionMode(true);
			return;
		}

		//if OK button pressed
		if(eventObj == btnOK)
			{ setSelectionMode(false); return; }

		if(eventObj == btnFind) { findCustomer(); return; }

		if(eventObj == btnClear)
		{
			idTx.setText("");
			fnameTx.setText("");
			lnameTx.setText("");
			return;
		}

		if(e.getActionCommand().equals("LINK_SELECTED"))
		{
			int row = e.getID()/100,  col = e.getID() % 100;
			if(selectOption == SELECTOPTION_SINGLE) selectedCustomers.removeAllElements();
			else
			{	String[] cD = custTable.getText(row);
				int rId = custList.findText(cD[1]+" "+cD[2], 1);
				if(rId >= 0 && custList.getText(rId,0).equals(cD[0])) return;
			}
			selectedCustomers.addElement(custTable.getText(row));
			int cItems = selectedCustomers.size();
			String[][] cText = new String[cItems][8];
			for(int i=0; i < cItems; i++)
			{	String[] cData = (String[])(selectedCustomers.elementAt(i));
				cText[i][0] = cData[0]; cText[i][1] = cData[1]+" "+cData[2]; cText[i][2] = cData[4]; cText[i][3] = cData[5];
			}
			custList.setText(cText);
			if(selectOption == SELECTOPTION_SINGLE) { setSelectionMode(false); return; }
		}
	}

	void resetForSelection()
	{
		AppConfig.getActiveModule().reset();
		selectedCustomers.removeAllElements();
		custList.reset();
	}

	//Key Listener Interface Implementation
	public void keyTyped(KeyEvent e)
	{
		Object eventObj = e.getSource();
		if(eventObj == idTx)
		{	fnameTx.setText(""); lnameTx.setText("");
			reqDocType = AppConfig.DOC_ACCOUNT_ID;
		}
		else if(eventObj == fnameTx)
		{	idTx.setText(""); lnameTx.setText("");
			reqDocType = AppConfig.DOC_ACCOUNT_FNAME;
		}
		else if(eventObj == lnameTx)
		{	idTx.setText(""); fnameTx.setText("");
			reqDocType = AppConfig.DOC_ACCOUNT_LNAME;
		}
		if(e.getKeyChar() == 10) //if Enter Key Pressed
			findCustomer();
		//XToolkit.showMessage("The key pressed is :"+(int)(e.getKeyChar()));
	}
	public void keyPressed(KeyEvent e)  { }
	public void keyReleased(KeyEvent e) { }


	//Load and Display Customer Data
	void loadCustomerData(String subCriteria)
	{
		long fTime = AppConfig.DocumentFetchTime[custDocType];
		if(System.currentTimeMillis()-fTime > AppConfig.CacheTimeout || AppConfig.DocumentCache[custDocType] == null)
		{
		//show wait message to the poor user
		XToolkit.showProgressMessage("Loading customer data. Please wait......");
		XMLParser parser = AppConfig.getParser();
		Document reqDoc = parser.createDocument("Request");
		Element root = reqDoc.getDocumentElement();
		root.setAttribute("ID", ""+ReqDef.ACCOUNTLISTC);
		root.setAttribute("SortId", "0");
		String criteria = " where b.account_id=a.id And a.ispvn_id="+AppConfig.ispvnIDList[AppConfig.curIspvnIndex]+
								" And rownum between 1 and 200 "+subCriteria;
		if(custDocType == AppConfig.DOC_ACCOUNT_ID) criteria += " order by a.Id";
		else if(custDocType == AppConfig.DOC_ACCOUNT_FNAME) criteria += " order by upper(a.firstname)";
		else criteria += " order by upper(a.surname)";
		root.setAttribute("Criteria", criteria);
		AppConfig.getCommunicator().processXMLRequest(reqDoc, this, 1);
		}
		else custTable.loadDocument(AppConfig.DocumentCache[custDocType]);
	}

	//handle data from HttpCommunicator
	public void receiveHttpData(Object data, int dataID)
	{
		XToolkit.hideProgressMessage();
		Document doc = (Document)data;
		if(doc == null) return;
		AppConfig.DocumentFetchTime[custDocType] = System.currentTimeMillis();
		AppConfig.DocumentCache[custDocType] = doc;
		custTable.loadDocument(doc);
	}

	public Vector getSelectedCustomers() { return selectedCustomers; }

	public boolean hasCustomers()
	{
		if(selectedCustomers.size() < 1)
		{
			XToolkit.showMessage("No Customer(s) selected !", "Please select a customer(s) first");
			return false;
		}
		return true;
	}

	void findCustomer()
	{
		String ID = idTx.getText().trim();
		String fName = fnameTx.getText().trim();
		String lName = lnameTx.getText().trim();
		String subQtext = "";
		int    found=-1;
		boolean reloadRequired = false;

		custDocType = reqDocType;

		if(AppConfig.DocumentCache[custDocType] == null) reloadRequired = true;
		else
		{
			custTable.loadDocument(AppConfig.DocumentCache[custDocType]);
			if(custDocType == AppConfig.DOC_ACCOUNT_ID)
				found = custTable.findText(ID, 0);
			else if(custDocType == AppConfig.DOC_ACCOUNT_FNAME)
				found = custTable.findText(fName, 1);
			else if(custDocType == AppConfig.DOC_ACCOUNT_LNAME)
				found = custTable.findText(lName, 2);
			if(found >= 0)
			{	cMsg.setText("Search Successful !");
				return;
			}
			else reloadRequired = true;
		}

		cMsg.setText("Search Results :");

		if(custDocType == AppConfig.DOC_ACCOUNT_ID)
		{	if(ID.length() > 0) subQtext = " And a.Id >= "+ID; }
		else if(custDocType == AppConfig.DOC_ACCOUNT_FNAME)
		{	if(fName.length() > 0) subQtext = " And upper(a.firstname) like '"+fName.toUpperCase()+"%'"; }
		else if(custDocType == AppConfig.DOC_ACCOUNT_LNAME)
		{	if(lName.length() > 0) subQtext = " And upper(a.surname) like '"+lName.toUpperCase()+"%'"; }

		AppConfig.DocumentCache[custDocType] = null;
		loadCustomerData(subQtext);
	}
}
