import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

public class ToolsApp extends Panel implements AppModule, ActionListener, HttpListener
{

	public ToolsApp()
	{
		this.setLayout(null);
		this.setBounds(AppConfig.ClientIndent, 0, AppConfig.ClientWidth, AppConfig.TotalHeight);
		this.setBackground(AppConfig.Color_Client);

		Button tb = new Button("Test XGrid");
		tb.setBounds(50, 50, 100, 22);
		tb.addActionListener(this);
		this.add(tb);

	}

	public void paint(Graphics g)
	{
		g.setColor(AppConfig.Color_ModuleTitleBar);
		g.fillRect(0, 0, AppConfig.ClientWidth, 20);
		XToolkit.setColorScheme(XToolkit.COLORSCHEME_SOFT3D);
		XToolkit.draw3DBox(g, 0, 0, AppConfig.ClientWidth+1, 21, true);
		g.setColor(Color.white);
		g.setFont(AppConfig.Font_ModuleTitle);
		g.drawString(moduleName[TOOLS], 5, 16);
	}


	//AppModule interface methods
	public short getModuleID() { return AppModule.TOOLS; }

	public Container getModuleContainer() { return this; }

	public void setActive(boolean state)
	{
		if(state) AppConfig.setActiveModule(this);
		this.setVisible(state);
	}

	public void reset() { }

	//ActionListener interface
	public void actionPerformed(ActionEvent e)
	{
		if(e.getActionCommand().equals("LINK_SELECTED"))
		{
			int row = e.getID()/100,  col = e.getID() % 100;
			//System.out.println("Link Row: "+row+"  Col: "+col);
			return;
		}
		//try {
		//appContext.showDocument(new URL(getDocumentBase(),"event.html"), "Footer");
		//} catch (Exception ex) { System.out.println("URL Error: "+ex.toString()); }
		testXGrid();
	}

	void testXGrid()
	{
//XToolkit.showProgressMessage("Getting Customer Invoices. Please wait......");
XToolkit.showMessage("Getting Customer Invoices. Please wait......");
		XMLParser parser = AppConfig.getParser();
		Document reqDoc = parser.createDocument("Request");
		Element root = reqDoc.getDocumentElement();
		root.setAttribute("ID", ""+ReqDef.ACCOUNTLISTC);
		AppConfig.getCommunicator().processXMLRequest(reqDoc, this, 101);
	}

XGrid tg;
	//handle data from HttpCommunicator
	public void receiveHttpData(Object data, int dataID)
	{
		Document doc = (Document)data;
		if(doc == null) return;
		if(tg == null)
		{	tg = new XGrid();
			tg.setColumns(new int[]{100, 100});
			tg.setHeader(new String[]{ "ID", "LastName" });
			tg.setBounds(50, 100, 500, 240);
			//tg.setBackground(Color.red);
			//tg.setBackground(new Color(228, 228, 228));
			tg.displayPageTabs(true);
			tg.setColProperty(0, XGrid.PROP_TEXTCOLOR, Color.red);
			tg.setColProperty(0, XGrid.PROP_TEXTFONT, AppConfig.Font_B12);
			tg.setColProperty(0, XGrid.PROP_DATALINK, "Y");
			tg.setBorderV(0);
			tg.setLinkListener(this, "LINK_SELECTED");
			this.add(tg);
		}
		tg.loadDocument(doc);
		//this.invalidate();
		//tg.repaint();
	}

}
