import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

public class UtilsApplet extends java.applet.Applet
{
	private java.applet.AppletContext appContext;
	private URL cURL;
	private URLConnection cURLConnection;
	private boolean doEncryption=true;

	private EncryptedInputStream  eIn  = new EncryptedInputStream();
	private EncryptedOutputStream eOut = new EncryptedOutputStream();


	public void init()
	{
		//get Applet Context
		appContext = this.getAppletContext();
	}

	public void setURL(String url)
	{
		try
		{
			cURL = new URL(url);
		} catch (Exception e)
		{ System.out.println("Error: \n  HttpCommunicator error: "+e.toString()); }
	}

	public String processRequest(String reqStr)
	{
		if(cURL == null) return null;
		int blkSize=8192;
		byte[] xBytes = new byte[blkSize];
		StringBuffer xBuf = new StringBuffer();

		try
		{	cURLConnection = cURL.openConnection();
			cURLConnection.setRequestProperty("Content-Type", "application/x-billing");
			if(reqStr != null)
			{	cURLConnection.setDoOutput(true);
				OutputStream out = cURLConnection.getOutputStream();
				if(doEncryption) { eOut.setOutputStream(out); out=eOut; }
				out.write(reqStr.getBytes());
				out.close();
			}
			InputStream in = (InputStream)(cURLConnection.getContent());
			if(doEncryption) { eIn.setInputStream(in); in=eIn; }
			while(true)
			{	int nb = in.read(xBytes, 0, blkSize);
				if(nb < 0) break;
				if(nb > 0) xBuf.append(new String(xBytes, 0, nb));
			}
			in.close();
			return xBuf.toString();
		}  catch (Exception e)
		{  System.out.println("Error: \n  HttpCommunicator error: "+e.toString()); }

		return null;
	}

	public String hexToURL(String sHex)
	{
			StringBuffer tBuf = new StringBuffer();
			char[] uChars = sHex.toCharArray();
			int len = uChars.length;

			for(int i=0; i < len; i += 2) tBuf.append((char)(Integer.parseInt(new String(uChars, i, 2), 16)));
			return tBuf.toString();
	}
}
